using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        DataSet parentds = new DataSet();
        parentds.ReadXml(Server.MapPath("~/App_Data/ProductsList.xml"));

        DataTable parent = parentds.Tables[0];
        DataTable child = parentds.Tables[0];
        DataTable grandchild = parentds.Tables[0];

        DataColumn[] key = new DataColumn[1];
        key[0] = parent.Columns[0];
        parent.PrimaryKey = key;
        child.PrimaryKey = key;
        grandchild.PrimaryKey = key;

        GridRelationDescriptor parentToChildRelationDescriptor = new GridRelationDescriptor();
        parentToChildRelationDescriptor.ChildTableName = "MyChildTable";    // same as SourceListSetEntry.Name for childTable (see below)
        parentToChildRelationDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
        parentToChildRelationDescriptor.RelationKeys.Add("parentID", "ParentID");

        // Add relation to ParentTable 
        GridGroupingControl1.TableDescriptor.Relations.Add(parentToChildRelationDescriptor);

        GridRelationDescriptor childToGrandChildRelationDescriptor = new GridRelationDescriptor();
        childToGrandChildRelationDescriptor.ChildTableName = "MyGrandChildTable";  // same as SourceListSetEntry.Name for grandChhildTable (see below)
        childToGrandChildRelationDescriptor.RelationKind = RelationKind.RelatedMasterDetails;
        childToGrandChildRelationDescriptor.RelationKeys.Add("childID", "ChildID");

        // Add relation to ChildTable 
        parentToChildRelationDescriptor.ChildTableDescriptor.Relations.Add(childToGrandChildRelationDescriptor);

        this.GridGroupingControl1.Engine.SourceListSet.Add("MyParentTable", parent);
        this.GridGroupingControl1.Engine.SourceListSet.Add("MyChildTable", child);
        this.GridGroupingControl1.Engine.SourceListSet.Add("MyGrandChildTable", grandchild);

        this.GridGroupingControl1.DataMember = "DefaultView";
        GridGroupingControl1.DataSource = parent;
    }

}

